;A very cool ti-86 like shell. ;)
#include	"usgard.h"

#define _QVIEW
#define _QFOLDER
.org    0
#ifdef _QVIEW
.db     "Future OS v1.5.0 (Lite)",0
#else
.db     "Future OS v1.5.0 - Lite",0
#endif

MAXP = 14                               ;MAXIMAL NUMBER OF PROGRAMS
MAX_PROGS =     TEXT_MEM
OLD_CX =        TEXT_MEM+3
PROGRAMS =      TEXT_MEM2               ;STORES PROGRAM NAMES

        ld      HL, &Name
        ld      DE, USGSHELL
        ld      BC, 9
        ldir

        ld      C, 0
StartNew:
        ld      HL, VAT_START-10
        ld      (&VAT_Find+1), HL

Start:
;Draw the screen
        push    BC
        call    CLEARLCD

        ld      HL, VIDEO_MEM
        ld      DE, VIDEO_MEM+1
        ld      (HL), 255
        ld      BC, 111
        ldir

        set     3, (iy+05)
        ld      HL, $0001
        ld      (CURSOR_X), HL
        ld      HL, (PROGRAM_ADDR)
        call    D_ZM_STR
#ifdef _QFOLDER
	ld a,$6A ;5E
	ld ($8333),a
	ld a,(&var_kind)
	cp $0C
	jr z,QFGAMES
	cp $2C
	jr z,QFUTILS
	cp $4C
	jr z,QFOTHER
	cp $6C
	jr z,QFSTUFF
	cp $12
	jr z,QFTWEAK
	cp $14
	jr z,QFHIDDEN
QFGAMES:
	ld hl,&MenuF1Txt
	jr ShowFolderName
QFUTILS:
	ld hl,&MenuF2Txt
	jr ShowFolderName
QFOTHER:
	ld hl,&MenuF3Txt
	jr ShowFolderName
QFSTUFF:
	ld hl,&MenuF4Txt
	jr ShowFolderName
QFTWEAK:
	ld hl,&MenuF5Txt
	jr ShowFolderName
QFHIDDEN:
	ld hl,&MenuEETxt
	jr ShowFolderName  
ShowFolderName:
	call D_ZM_STR
#endif
        res     3, (iy+05)

        ld      HL, VIDEO_MEM+112
        ld      DE, 5
        ld      B, 43
VertLines:
        add     HL, DE
        ld      (HL), 00100000b
        add     HL, DE
        ld      (HL), 00000101b
        add     HL, DE
        inc     HL
        djnz    VertLines

        ld      B, 16
HorizLine:
        ld      (HL), 255
        inc     HL
        djnz    HorizLine

ChoiceFOLDER:
        call    &DisplayMenu

        ld      de, $3A03
        ld      (CURSOR_X), de
        ld      hl, &MenuF1Txt
        call    D_ZM_STR
        ld      a, 28
        ld      (CURSOR_X), a
        ld      hl, &MenuF2Txt
        call    D_ZM_STR
        ld      a, 53
        ld      (CURSOR_X), a
        ld      hl, &MenuF3Txt
        call    D_ZM_STR
        ld      a, 78
        ld      (CURSOR_X), a
        ld      hl, &MenuF4Txt
        call    D_ZM_STR
        ld      a, 103
        ld      (CURSOR_X), a
        ld      hl, &MenuF5Txt
        call    D_ZM_STR
BLOCK3:
 	 ld hl,$FF90
Inv:
	 ld	a,(hl)
	 cpl
	 ld	(hl),a
	 inc	hl
	 djnz	Inv
#endif
	call	&COOLFuture
	
;Find available programs:
Start_VAT:
        ld      HL, $0701
        ld      (CURSOR_X), HL

VAT_Find:
        ld      HL, VAT_START-10
        ld      IX, TEXT_MEM2
        xor     A
        ld      (MAX_PROGS), A

VAT_Loop:
        ld      A, (&var_kind)
        call    SEARCH_VAT
        jr      c, VAT_Done
        ld      A, (DE)
        and     A
        jr      nz, VAT_Loop
        inc     DE
        ld      A, (DE)
DispType:
        cp      PROG_HEADER
        jr      c, VAT_Loop
        push    HL
        inc     DE
        inc     DE
        ld      HL, (PROGRAM_ADDR)
        or      A
        sbc     HL, DE                  ;'CP_HL_DE'
        pop     HL
        jr      z, VAT_Loop             ;this is the actual shell, skip it
;Copy name:
        push    IX
        pop     DE
        push    HL
        ld      HL, VATName
        ld      BC, 9
        ldir
        pop     HL
        push    DE
        pop     IX
;Write out name:
        push    HL
        ld      HL, VATName
        ld      A, (CURSOR_X)
        ld      (OLD_CX), A
        call    D_ZM_STR
        ld      HL, CURSOR_X
        ld      A, (OLD_CX)
        dec     A
        ld      A, 44
        jr      z, SetCursorX
        inc     HL
        ld      A, (HL)
        add     A, 6
        ld      (HL), A
        dec     HL
        ld      A, 1
SetCursorX:
        ld      (HL), A

        ld      HL, MAX_PROGS
        inc     (HL)
        ld      A, (HL)
        pop     HL

        cp      MAXP
        jr      c, VAT_Loop
VAT_Done:
        pop     BC

        ld      A, (MAX_PROGS)
        and     A
        jr      nz, VAT_Done_1
        ld      HL, (&VAT_Find+1)
        ld      DE, VAT_START-10
        call    CP_HL_DE
        jr      z, NoPrograms
        ld      (&VAT_Find+1), DE
        jp      &Start
NoPrograms:
        ld      HL, &NoProgs
        call    D_ZM_STR
;;;
NoPrograms2:
        halt
        call    GET_KEY
        and     A
        jr      z, NoPrograms2
        call    &InvertCur
        call    $115
        ld      (IY+8), $84
        cp      K_EXIT
	ret	z
        cp      K_F1
        jp z,	&Folder_F1		;Allow to change to another Folder if no progs found
        cp      K_F2
        jp z,	&Folder_F2
        cp      K_F3
        jp z,	&Folder_F3
        cp      K_F4
        jp z,	&Folder_F4
        cp      K_EE
        jp z,	&Folder_EE
        ret
VAT_Done_1:
        cp      MAXP
        jr      z, SetVAT
        ld      HL, VAT_START-10
SetVAT:
        ld      (&VATPos), HL

        dec     A
        ld      (MAX_PROGS), A
Program_Show:
        push    BC
        ld      HL, VIDEO_MEM+(51*16)
        ld      BC, 16*7
        call    OTH_CLEAR
        ld      HL, $3301
        ld      (CURSOR_X), HL
        pop     BC
        push    BC
        call    &GetProgram
        pop     BC
        call    VAR_GET
        push    HL
        inc     HL
#ifdef _QVIEW
        ld      A, (HL)
        cp      PROG_HEADER
        jr      c, DontDisplay
#endif
        inc     HL
        inc     HL
        call    D_ZM_STR
DontDisplay:
        ld      HL, VIDEO_MEM+11+112
        ld      B, 24
ClearSpace:
        push    BC
        ld      BC, 4
        call    OTH_CLEAR
        ld      C, 12
        add     HL, BC
        pop     BC
        djnz    ClearSpace

        ld      HL, $0759
        ld      (CURSOR_X), HL
        ld      HL, &Size
        call    D_ZM_STR
        pop     HL
#ifdef _QVIEW
        push    HL
#endif
        dec     HL
        dec     HL
        call    LD_HL_MHL
        call    DM_HL_DECI
        ld      HL, $0D59
        ld      (CURSOR_X), HL
        ld      HL, &Mem
        call    D_ZM_STR
        push    BC
        call    FREEMEM
        pop     BC
        call    DM_HL_DECI
#ifdef _QVIEW
        ld      HL, $1359
        ld      (CURSOR_X), HL
        ld      HL, &TypeTxt
        call    D_ZM_STR
        ld      HL, &TypeTab
        call    VAR_GET
        ex      DE, HL
        pop     HL
        inc     HL
        ld      A, (HL)			;get type
        jr      c, DispNumber
        push    DE
        ld      H, 3
        sub     $7D
        ld      L, A
        call    MUL_HL
        pop     DE
        add     HL, DE
        ld      B, 3
DispText:
        ld      A, (HL)
        call    M_CHARPUT
        inc     HL
        djnz    DispText
        jr      DispDone
DispNumber:
	cp	$FD
	jr z,	Type1
	cp	$FB
	jr z,	Type2
	cp 	$F9
	jr z, 	Type3
	cp 	$F8
	jr z, 	Type4
	cp 	$7D
	jr z, 	Type5
	cp 	$7E
	jr z, 	Type6
	cp 	$7F
	jr z, 	Type7
	cp 	$80
	jr z, 	Type8
	cp 	$81
	jr z, 	Type9
	cp 	$90
	jr z, 	Type0
Type1:
	ld 	hl,&T1
	jr 	ContDisp1
Type2:
	ld 	hl,&T2
	jr 	ContDisp1
Type3:
	ld 	hl,&T3
	jr 	ContDisp1
Type4:
	ld 	hl,&T4
	jr 	ContDisp1
Type5:
 	ld 	hl,&T5
 	jr 	ContDisp1
Type6:
	ld 	hl,&T6
	jr 	ContDisp1
Type7:
 	ld 	hl,&T7
 	jr 	ContDisp1
Type8:
 	ld 	hl,&T8
 	jr 	ContDisp1
Type9:
 	ld 	hl,&T9
 	jr 	ContDisp1
Type0:
 	ld 	hl,&T0

ContDisp1:
 	ld 	(TEXT_MEM+1),hl
 	ld 	hl,$136F
 	ld 	($8333),hl
 	ld 	hl,(TEXT_MEM+1)
 	call 	D_ZM_STR
DispDone:

ProgramLoop:
        ld      (IY+8), $8C
        call    &InvertCur
KeyLoop:
        halt
        call    GET_KEY
        and     A
        jr      z, KeyLoop
        call    &InvertCur
        call    $115
        ld      (IY+8), $84
        cp      K_EXIT
        ret     z
        cp      K_UP
        jr      z, Up
        cp      K_DOWN
        jr      z, Down
        cp      K_LEFT
        jr      z, Left
        cp      K_RIGHT
        jr      z, Right
        cp	K_F1
	jp	z, &Folder_F1
        cp	K_F2
	jp	z, &Folder_F2
        cp	K_F3
	jp	z, &Folder_F3
	cp	K_F4
	jp	z, &Folder_F4
	cp	K_F5
	jp	z, &Folder_F5
	cp	K_EE
	jp	z, &Folder_EE
	cp	K_STO
	jp	z,&MoveFolderLoop
        cp      K_MORE
        jr      z, NextPage
        cp      K_SECOND
        jr      z, Exec
        cp      K_ENTER
        jr      z, Exec
        ld      hl, CONTRAST
        cp      K_PLUS
        jr      z, ContUp
        cp      K_MINUS
        jr      z, ContDown
        cp      K_DEL
        jp      z, &Del
        cp      K_ALPHA
        call    z, OTH_SHUTDOWN
        jr      ProgramLoop
ProgramLoopTRIP:
	jr	ProgramLoop

ContDown:
        ld      A, (HL)
        sub     1
        jr      c, ProgramLoopTRIP
        ld      (HL), A
        jr      SetContr
        jr      ProgramLoopTRIP
ContUp:
        ld      A, (HL)
        cp      31
        jr      z, ProgramLoopTRIP
        inc     (HL)
        ld      A, (HL)
SetContr:
        out     (2), A
        jr      ProgramLoopTRIP

Left:
        ld      A, C
        and     A
        jr      z, NextPage
DoLeft:
        dec     C
J_Prog:
        jp      &Program_Show
Right:
        ld      A, C
        ld      HL, MAX_PROGS
        cp      (HL)
        jr      z, NextPage
DoRight:
        inc     C
        jr      J_Prog
Up:
        ld      A, C
        cp      2
        jr      c, NextPage
        dec     C
        jr      DoLeft
Down:
        ld      A, C
        ld      HL, MAX_PROGS
        inc     A
        cp      (HL)
        jr      nc, NextPage
        inc     C
        jr      DoRight

NextPage:
        ld      C, 0
        ld      HL, (&VATPos)
        ld      (&VAT_Find+1), HL
JumpStart:
        jp      &Start

GetProgram:
        ld      H, 9
        ld      L, C
        call    MUL_HL
        ld      DE, TEXT_MEM2
        add     HL, DE
        ret

Exec:
        push    BC
        call    &GetProgram
#ifdef _QVIEW
        push    HL
#endif
        call    VAR_EXEC
#ifdef _QVIEW
        pop     HL
        jr      c, Disp_QView
#endif
        im      2
        pop     BC
        call    GET_KEY
        ld      HL, USG_BITS
        bit     1, (HL)
        call    nz, OTH_EXIT
        ld      A, 4
        out     (5), A
        jr      JumpStart
#ifdef  _QVIEW
Disp_QView:
        ld      DE, OP2
        ld      BC, 9
        ldir
        ld      HL, &QView
        call    VAR_EXEC
        pop     BC
        jr      JumpStart

ChangeDisplay:
        ld      HL, &DispType+1
        ld      A, (HL)
        cp      PROG_HEADER
        jr      z, DisplayAll
        ld      DE, $FE00+PROG_HEADER
        jr      SetDisp
DisplayAll:
        ld      DE, 0
SetDisp:
        ld      (HL), E
        dec     HL
        ld      (HL), D
        ld      C, 0
        jr      JumpStart
#endif

Del:
        set     3, (IY+5)
        ld      HL, $0503
        ld      (CURSOR_ROW), HL
        ld      HL, &Delete
        call    D_ZT_STR
Del_Wait:
        halt
        call    GET_KEY
        and     A
        jr      z, Del_Wait
        cp      K_ENTER
        jr      z, Del_Really
        res     3, (IY+5)
        jr      JumpStart
Del_Really:
        call    &GetProgram
        call    VAR_DELETE
        ld      C, 0
        jr      JumpStart

InvertCur:
        push    AF
        xor     A
        bit     0, C
        jr      z, Invert_0
        ld      A, 43
Invert_0:
        ld      D, A
        ld      H, 96
        ld      L, C
        srl     L
        push    DE
        call    MUL_HL
        ld      DE, VIDEO_MEM+112
        add     HL, DE
        pop     DE
;Invert 7 lines at HL, from D - D+40.
Invert:
        push    HL
        push    BC
        ld      B, D
        ld      C, 63
        call    FIND_PIXEL
        pop     BC
        ex      DE, HL
        pop     HL
        add     HL, DE
;NOW:   HL = where to invert, B = pixels to invert, D = start mask
        ld      D, A
        pop     AF
        ld      E, 7
Invert_1:
        push    AF
        push    BC
        ld      C, D
InvLoop:
        ld      B, 42
InvertLoop:
        ld      A, (HL)
        xor     D
        ld      (HL), A
        rrc     D
        jr      nc, InvertLoop_1
        inc     HL
InvertLoop_1:
        djnz    InvertLoop
        ld      D, C
        ld      BC, 11
        add     HL, BC
        ld      C, D
        dec     E
        jr      nz, InvLoop
        pop     BC
        pop     AF
        ret
;********************* Display Menu routine *************************
DisplayMenu:
        ld      hl, VIDEO_MEM+$380
        ld      b, 32
DisplayMenuLoop1:
        ld      (hl), $FF
        inc     hl
        djnz    DisplayMenuLoop1

        ld      b, 36
        ld      a, %11000000
        or      a
DisplayMenuLoop2:
        ld      (hl), a
        inc     hl
        inc     hl
        inc     hl
        rra
        cp      3
        jr      nz, DisplayMenuLoop2
        ld      a, $C0
        dec     hl
        dec     hl
        djnz    DisplayMenuLoop2

        ld      a, $FE
        ld      (VIDEO_MEM+$38F), a
        ld      (VIDEO_MEM+$39F), a
        ret
;********************* Change Folders routine *************************
; $0C - 12 Games folder, increments of $20 or 32 will still be valid strings
; $E0 is the highest possible folder allowing a total 8 valid string folders
; using other types than strings although possible, will be seen as corruption
; by Ti-OS and therefore is not safe to use.
;
; Through research and hacking variable types I have come to learn that any type
; incremented by $20 or 32 will still be the same type and when sent through the
; link port to another calc, will be reset the the initial type (I.E. $6C changes 
; to $0C)
;
; This should be enough information to get you going well with your custom interface
;
Folder_F1:				;kind = $0C (Games)
	LD 	A,$0C
	LD 	(&var_kind),A
	JUMP_(DoneHere)
Folder_F2:				;kind = $2C (Utils)
	LD 	A,$2C
	LD 	(&var_kind),A
	JUMP_(DoneHere)
Folder_F3:				;kind = $4C (Other)
	LD 	A,$4C
	LD 	(&var_kind),A
	JUMP_(DoneHere)
Folder_F4:				;kind = $6C (Plugs)
	LD 	A,$6C
	LD 	(&var_kind),A
	JUMP_(DoneHere)
Folder_F5:				;Display About Screen
	call 	&About_FOS
	JUMP_(DoneHere)
Folder_EE:				;kind = $14 (Hidden)
	LD 	A,$14
	LD 	(&var_kind),A
	JUMP_(DoneHere)
;*****************************************(Move programs routine)
MoveFolderLoop:
        ld      de, $3309	;3A03
        ld      (CURSOR_X), de
        ld      hl, &MoveTxt
        call    D_ZM_STR
        
        ld      (IY+8), $8C
MFolderLoop:
        halt
        call    GET_KEY
        and     A
        jr	z, MFolderLoop
        call    $115				; update APD to 5min again
        ld      (IY+8), $84
        cp      K_EXIT
        ret     z
        cp	K_F1
	jp	z, &MFolder_F1
        cp	K_F2
	jp	z, &MFolder_F2
        cp	K_F3
	jp	z, &MFolder_F3
	cp	K_F4
	jp	z, &MFolder_F4
	cp	K_EE
	jp	z, &MFolder_EE
        cp      K_ALPHA
        call    z, OTH_SHUTDOWN
        jr      MoveFolderLoop
;*****************************************(F1)
MFolder_F1:		;kind = $0C (Games)
        push    BC
        call    &MoveGetProgram
	call	VAR_GET
	ld 	a, $0C
	ld 	(de),a
	jr	z, MoveExec1
;*****************************************(F2)
MFolder_F2:		;kind = $2C (Utils)
        push    BC
        call    &MoveGetProgram
	call	VAR_GET
	ld 	a, $2C
	ld 	(de),a
	jr	z, MoveExec1
;*****************************************(F3)
MFolder_F3:		;kind = $4C (Other)
        push    BC
        call    &MoveGetProgram
	call	VAR_GET
	ld 	a, $4C
	ld 	(de),a
	jr	z, MoveExec1
;*****************************************(F4)
MFolder_F4:		;kind = $6C (Plugs)
        push    BC
        call    &MoveGetProgram
	call	VAR_GET
	ld 	a, $6C
	ld 	(de),a
	jr	z, MoveExec1
;*****************************************(EE)
MFolder_EE:		;kind = $14 (Hidden)
        push    BC
        call    &MoveGetProgram
	call	VAR_GET
	ld 	a, $14
	ld 	(de),a
	jr	z, MoveExec1
	ret
  
MoveGetProgram:
        ld      H, 9
        ld      L, C
        call    MUL_HL
        ld      DE, TEXT_MEM2
        add     HL, DE
        ret

MoveExec1:
        im      2
        pop     BC
        call    GET_KEY
        ld      HL, USG_BITS
        bit     1, (HL)
        call    nz, OTH_EXIT
        ld      A, 4
        out     (5), A
        
	ld	a, (&var_kind)
	dec	c
	jp	&JumpStart        
DoneHere:
	ld	a, (&var_kind)
	ld	c, 0
	jp	&JumpStart
	
About_FOS:
 	ld	hl, &AboutFOS

	call	VAR_EXEC
	ret	c
	ld	hl, USG_BITS
	bit	1, (hl)
	ld	c, 0
	ret
 	jp	&JumpStart
	ret

VATPos:
        .dw 0
var_kind:
	.db $0C
NoProgs:
        .db "No Progs",0
Name:
        .db "futurel",0
Size:
        .db "Size:",0
Mem:
        .db "Free:",0
Delete:
        .db "Del?(ENTER)",0
MoveTxt:
 	.db "       Move to what Folder?  ",0
MenuF1Txt:
 	.db "Games",0
MenuF2Txt:
 	.db "Utils",0
MenuF3Txt:
 	.db "Other",0
MenuF4Txt:
 	.db "Plugs",0
MenuF5Txt:
 	.db "About",0
MenuEETxt:
 	.db "Hidden",0
AboutFOS:
 	.db "xfosabot",0 
#ifdef _QVIEW
T1: 	.db "Zsh 4",0
T2: 	.db "U 1.0",0
T3: 	.db "U 1.1",0
T4: 	.db "U 1.5",0
T5: 	.db "B/W i",0
T6: 	.db "GR4 i",0
T7: 	.db "GR8 i",0
T8: 	.db "ZCP i",0
T9: 	.db "GCP i",0
T0: 	.db "F Lib",0
TypeTxt:
	.db "Type:",0
QView:
        .db "qview",0
TypeTab:
        .db "typetab",0
#endif
FosPic:
	.db %00011000,%11000000,%00000000,%00000000,%11001110
	.db %00111111,%10000000,%00000000,%00000001,%10101011
	.db %00010000,%00001000,%00000000,%00000001,%10101001
	.db %00110101,%00011000,%00000000,%00000001,%10101100
	.db %00111110,%00001100,%00000000,%00000001,%10101100
	.db %00111010,%10101001,%01010100,%01100001,%01100110
	.db %00100000,%10101001,%01011010,%10100001,%01101011
	.db %00110000,%10101101,%01010000,%11001001,%11101011
	.db %00010000,%01001000,%10010000,%01110000,%01000110
#include "fosgfx.asm"
.end